from datetime import datetime

favoriteDevice = None

################################################################################
def setDevice(device) :
  global favoriteDevice
  favoriteDevice = device
################################################################################

################################################################################
def getDevice() :
  global favoriteDevice
  return favoriteDevice
################################################################################

################################################################################
def timeStamp() :
  return "[%s]"%datetime.now().strftime("%H:%M:%S")
################################################################################

################################################################################
def isEmpty(value) :
  return value == "_" or value == ""
################################################################################

################################################################################
def prettyInt(value, p) :
  l =  ['' for _ in range((p-len(str(value))%p)%p)] + list(str(value))
  l = ["".join(l[i:i+p]) for i in range(0,len(l),p)]
  return " ".join(l)
################################################################################

################################################################################
def numParameters(model) :
  return sum(p.numel() for p in model.parameters() if p.requires_grad)
################################################################################

